import React, { useState } from 'react'
import Pagination from '../pagination/Pagination'

const AutomatedAnswerSwiper = ({ children }) => {
  const [currentIndex, setCurrentIndex] = useState(0)
  const onBtnClick = (index) => {
    console.log('here' + index)
    if (index < children.length) {
      setCurrentIndex(index)
    }
  }

  return (
    <div className="automated">
      <Pagination
        currentIndex={currentIndex}
        length={children.length}
        onBtnClick={onBtnClick}
        onClickFirst={() => setCurrentIndex(0)}
        onClickLast={() => setCurrentIndex(children.length - 1)}
      />
      {children[currentIndex]}
    </div>
  )
}

export default AutomatedAnswerSwiper
