import { Snackbar } from '@material-ui/core'
import { Alert } from '@material-ui/lab'
import React, { useEffect } from 'react'

const NotificationSnack = ({
  message,
  severity,
  showSnackbar,
  setShowSnackbar,
  onClose = () => {},
  autoHideDuration = 5000,
  vertical = 'bottom',
  horizontal = 'left'
}) => {
  const [open, setOpen] = React.useState(showSnackbar)
  const onCloseSnack = (event, reason) => {
    setOpen(false)
    setShowSnackbar(false)
    onClose(event, reason)
  }

  useEffect(() => {
    setOpen(showSnackbar)
  }, [showSnackbar])
  return (
    <Snackbar
      open={open}
      autoHideDuration={autoHideDuration}
      onClose={onCloseSnack}
      anchorOrigin={{ vertical, horizontal }}
    >
      <Alert onClose={onCloseSnack} severity={severity} sx={{ width: '100%' }}>
        {message}
      </Alert>
    </Snackbar>
  )
}

export default NotificationSnack
