import Link from 'next/link'
import React from 'react'
import { Bold, Title } from '../../styled-text-spans/index'
import styles from './similar-question.module.css'

const SimilarQuestion = ({ question_prop }) => {
  const { id, question, description } = question_prop
  return (
    <Link href="/questions/[slug]" as={`/questions/${id}-${question}`}>
      <div className={styles.similarquestion}>
        <Link href="/users/[user]" as={`/users/dasun97`}>
          <div className={styles.userwrapper}>
            <img
              className={styles.profilephoto}
              src="https://www.practiceportuguese.com/wp-content/uploads/2020/06/asking-questions.jpg"
              alt="dasun97"
            />
            <Bold text={`@dasun97`} />
          </div>
        </Link>
        <div className={styles.questionwrapper}>
          <Title title={question} />
          <div>
            <Bold text={123} /> Views and <Bold text={2} />
            Comments
          </div>
        </div>
      </div>
    </Link>
  )
}

export default SimilarQuestion
