import { Typography } from '@material-ui/core'
import React from 'react'
import Button from '../../button'
import Verified from '../../icons/Verified'
import styles from './TelegramStatus.module.css'

const TelegramStatus = ({ isTelegramConnected }) => {
  return (
    <div className={styles.telegramStatus_wrapper}>
      {isTelegramConnected ? (
        <div className={styles.telegramStatus}>
          <Typography variant="h6">Telegram connected</Typography>
          <Verified />
        </div>
      ) : (
        <div className={styles.telegramStatus}>
          <Typography variant="h6">Telegram not connected</Typography>
        </div>
      )}
      <Button href="/telegram/connect" primary full>
        {isTelegramConnected ? 'Disconnect' : 'Connect'}
      </Button>
    </div>
  )
}

export default TelegramStatus
